#ifndef SETTINGS_H
#define SETTINGS_H

#define N_SETTINGS 4

typedef enum SyncSetting {
    SYNC_NONE = 0,
    SYNC_OUT_LINK_16,
    SYNC_OUT_LINK_8,
    SYNC_OUT_LINK_4,
    SYNC_OUT_AUDIO_16,
    SYNC_OUT_AUDIO_8,
    SYNC_OUT_AUDIO_4,
    SYNC_OUT_LINK_AUDIO_16,
    SYNC_OUT_LINK_AUDIO_8,
    SYNC_OUT_LINK_AUDIO_4,
    SYNC_IN_LINK,
    SYNC_NUM,
} SyncSetting;

char * sync_setting_str[] = {
    "NONE",
    "LINK OUT (16)",
    "LINK OUT (8)",
    "LINK OUT (4)",
    "AUDIO OUT (16)",
    "AUDIO OUT (8)",
    "AUDIO OUT (4)",
    "LINK+AUDIO OUT (16)",
    "LINK+AUDIO OUT (8)",
    "LINK+AUDIO OUT (4)",
    "LINK IN",
};

typedef enum  ThemeSetting {
    THEME_DEFAULT = 0,
    THEME_INVERTED,
    THEME_CLASSIC_BLUE,
    THEME_HUMAN_RIGHTS,
    THEME_AMBER,
    THEME_MERVEILLES,
    THEME_NUM,
} ThemeSetting;

char * theme_setting_str[] = {
    "DEFAULT",
    "INVERTED",
    "CLASSIC BLUE",
    "HUMAN RIGHTS",
    "AMBER",
    "MERVEILLES",
};

typedef enum  CursorSetting {
    CURSOR_THICK_LINE = 0,
    CURSOR_LINE,
    CURSOR_NUM,
} CursorSetting;

char * cursor_setting_str[] = {
    "THICK LINE",
    "LINE",
};

typedef enum HelpSetting {
    HELP_OFF = 0,
    HELP_ON,
    HELP_NUM,
} HelpSetting;

char * help_setting_str[] = {
    "OFF",
    "ON",
};

typedef struct Settings {
    SyncSetting sync;
    ThemeSetting theme;
    CursorSetting cursor;
    HelpSetting help;
    u8 reserved[63];
} Settings;

#endif // SETTINGS_H
